#include <stdio.h>
#include <pthread.h>
#include <unistd.h>

// A thread has its own stack but shares its heap with the other threads
// of the same process. Hence, both instances of toto have their own copy
// of i (allocated on the stack), but share the global variable x (allocated
// on the heap).

// Notice that there is a "race condition" when both processes access x.
// A process reads x from the heap, increments, then writes it back.
// Every now and then the scheduler will interrupt a thread during this
// sequence, so some values of x appear twice.

int x=0;

void* toto (void *arg)
{
	int i=0;
	while (1)
	{
		printf("toto copy %ld local=%d global=%d\n",(long)arg,++i,++x);
//		sleep(2);
	}
}

int main ()
{
	pthread_t t1,t2;
	pthread_create(&t1,NULL,toto,(void*)1);
//		sleep(1);
	pthread_create(&t2,NULL,toto,(void*)2);
	while (1) { sleep(5); }
}
